﻿-- Daily Tamer Check
-- by Fluffies
-- EU-Well of Eternity
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

local dtcicon = "Interface\\ICONS\\INV_MISC_PETMOONKINTA"

-- string colors
local LIGHT_RED   = "|cffFF2020"
local LIGHT_GREEN = "|cff20FF20"
local LIGHT_BLUE  = "|cff00ddFF"
local ZONE_BLUE   = "|cff00aacc"
local GREY        = "|cff999999"
local GOLD        = "|cffffcc00"
local function AddColor(str,color)
 return color..str.."|r"
end

local EKK   = 0; -- eastern kingdoms, kalimdor frame
local ONC   = 1; -- outlands, northrend, cataclysm frame
local ABOUT = 2; -- about frame

local mainframe,btnclose, -- dtc frame and its close button
      satchels_table, -- satchel tamers table
      out_north_cata_table, -- minor tamers table
      eastern_kalim_table, -- minor tamers table
      WEheader,WEtable  -- world events table
local frame = {}  -- minor tamers frames
local btn = {} -- minor tamers buttons
------- constants ------------------------------
local npcnamecolor = GREY
local zonecolor = ZONE_BLUE
local mainframenpcnamecolor = GREY
local mainframezonecolor = GREY

-- buttons' textures
local tx_btnnorth = "Interface\\icons\\Achievement_Zone_Northrend_01"
local tx_btnkalim = "Interface\\icons\\Achievement_Zone_Kalimdor_01"
local tx_btnabout = "Interface\\icons\\Icon_PetFamily_Beast"
local opt_framewidth = 200 -- frames maximum width
local opt_framespeed = 20  -- frames animation speed
--local worldeventschecked = false

       WEheader = EVENTS_LABEL
       WEtable = {}
       WEtable[CALENDAR_FILTER_DARKMOON] = { questID = 32175, name = "|TInterface\\icons\\INV_Misc_Eye_01:12|t "..CALENDAR_FILTER_DARKMOON.." (Jeremy Feasel)" }
       -- future world event tamers here
       satchels_table = { [select(2,GetAchievementInfo(7936))] = {
                  [32434] = "|TInterface\\icons\\INV_Pet_PandarenElemental_Fire:12|t "..AddColor(GetAchievementCriteriaInfo(6974,5),mainframezonecolor),
                  [32439] = "|TInterface\\icons\\Inv_pet_PandarenElemental:12|t "..AddColor(GetAchievementCriteriaInfo(6974,6),mainframezonecolor),
                  [32441] = "|TInterface\\icons\\INV_Pet_PandarenElemental_Earth:12|t "..AddColor(GetAchievementCriteriaInfo(6974,4),mainframezonecolor),
                  [32440] = "|TInterface\\icons\\INV_Pet_PandarenElemental_Air:12|t "..AddColor(GetAchievementCriteriaInfo(6974,1),mainframezonecolor)},
               [select(2,GetAchievementInfo(6606))] = {
                  [31957] = AddColor(GetAchievementCriteriaInfo(6974,6),mainframezonecolor)..AddColor(" (Shu)",mainframenpcnamecolor),
                  [31991] = AddColor(GetAchievementCriteriaInfo(6974,5),mainframezonecolor)..AddColor(" (Zusshi)",mainframenpcnamecolor),
                  [31956] = AddColor(GetAchievementCriteriaInfo(6974,4),mainframezonecolor)..AddColor(" (Yon)",mainframenpcnamecolor),
                  [31955] = AddColor(GetAchievementCriteriaInfo(6974,2),mainframezonecolor)..AddColor(" (Nishi)",mainframenpcnamecolor),
                  [31954] = AddColor(GetAchievementCriteriaInfo(6974,3),mainframezonecolor)..AddColor(" (Mo'ruk)",mainframenpcnamecolor),
                  [31953] = AddColor(GetAchievementCriteriaInfo(6974,1),mainframezonecolor)..AddColor(" (Hyuna)",mainframenpcnamecolor),
                  [31958] = AddColor(GetAchievementCriteriaInfo(6974,7),mainframezonecolor)..AddColor(" (Aki)",mainframenpcnamecolor)},
               [select(2,GetAchievementInfo(6607))] = {
                  [31935] = AddColor(GetAchievementCriteriaInfo(45,9),mainframezonecolor)..AddColor(" (Payne)",mainframenpcnamecolor), --icecrown
                  [31926] = AddColor(GetAchievementCriteriaInfo(44,7),mainframezonecolor)..AddColor(" (Antari)",mainframenpcnamecolor), --shadowmoon
                  [31916] = AddColor(GetAchievementCriteriaInfo(42,22),mainframezonecolor)..AddColor(" (Lydia)",mainframenpcnamecolor),
                  [31909] = AddColor(GetAchievementCriteriaInfo(43,6),mainframezonecolor)..AddColor(" (Trixxy)",mainframenpcnamecolor),
                  [31971] = AddColor(GetAchievementCriteriaInfo(4868,4),mainframezonecolor)..AddColor(" (Obalis)",mainframenpcnamecolor)} }
                  
out_north_cata_table = { [select(2,GetAchievementInfo(6604))] = { -- outlands
                  [31923] = AddColor(GetAchievementCriteriaInfo(44,2),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6604,2)..")",npcnamecolor), -- zangarmarsh
                  [31925] = AddColor(GetAchievementCriteriaInfo(44,3),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6604,4)..")",npcnamecolor), --terokk
                  [31924] = AddColor(GetAchievementCriteriaInfo(44,4),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6604,3)..")",npcnamecolor), --nagrand
                  [31922] = AddColor(GetAchievementCriteriaInfo(44,1),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6604,1)..")",npcnamecolor)},--hellfire
               [select(2,GetAchievementInfo(6605))] = {
                  [31931] = AddColor(GetAchievementCriteriaInfo(45,2),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6605,1)..")",npcnamecolor), --howling fjord
                  [31934] = AddColor(GetAchievementCriteriaInfo(45,5),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6605,4)..")",npcnamecolor), --zul drak
                  [31932] = AddColor(GetAchievementCriteriaInfo(45,7),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6605,2)..")",npcnamecolor), --crystalsong
                  [31933] = AddColor(GetAchievementCriteriaInfo(45,3),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6605,3)..")",npcnamecolor)}, --dragonblight
               [select(2,GetAchievementInfo(7525))] = {
                  [31973] = AddColor(GetAchievementCriteriaInfo(4868,3),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(7525,2)..")",npcnamecolor), --deepholm
                  [31972] = AddColor(GetAchievementCriteriaInfo(4868,1),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(7525,1)..")",npcnamecolor), --mount hyjal
                  [31974] = AddColor(GetAchievementCriteriaInfo(4868,5),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(7525,3)..")",npcnamecolor)} } --twilight highlands


eastern_kalim_table = { [select(2,GetAchievementInfo(6602)).." ("..FACTION_HORDE..")"] = { -- horde only (kalimdor)
                  [31854] = AddColor(GetAchievementCriteriaInfo(43,10),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,3)..")",npcnamecolor), --ashenvale
                  [31904] = AddColor(GetAchievementCriteriaInfo(43,7),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,8)..")",npcnamecolor), --southern barrens
                  [31819] = AddColor(GetAchievementCriteriaInfo(43,5),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,2)..")",npcnamecolor),--northrend barrens
                  [31908] = AddColor(GetAchievementCriteriaInfo(43,20),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,7)..")",npcnamecolor), --moonglade
                  [31905] = AddColor(GetAchievementCriteriaInfo(43,14),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,9)..")",npcnamecolor), --theramore?
                  [31906] = AddColor(GetAchievementCriteriaInfo(43,11),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,11)..")",npcnamecolor),--thousand needles
                  [31872] = AddColor(GetAchievementCriteriaInfo(43,13),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,5)..")",npcnamecolor), --desolace
                  [31871] = AddColor(GetAchievementCriteriaInfo(43,15),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,6)..")",npcnamecolor),--feralas
                  [31907] = AddColor(GetAchievementCriteriaInfo(43,18),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,10)..")",npcnamecolor),--felwood
                  [31862] = AddColor(GetAchievementCriteriaInfo(43,12),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,4)..")",npcnamecolor), --stonetalon
                  [31818] = AddColor(GetAchievementCriteriaInfo(43,1),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,1)..")",npcnamecolor)},--durotar
                        [select(2,GetAchievementInfo(6603)).." ("..FACTION_ALLIANCE..")"] = { -- alliance only (eastern kingdoms)
                  [31851] = AddColor(GetAchievementCriteriaInfo(42,17),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,6)..")",npcnamecolor), --cape of stranglethorn
                  [31910] = AddColor(GetAchievementCriteriaInfo(42,19),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,7)..")",npcnamecolor), --hinterlands
                  [31911] = AddColor(GetAchievementCriteriaInfo(42,24),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,8)..")",npcnamecolor),--eastern plaguelands
                  [31914] = AddColor(GetAchievementCriteriaInfo(42,5),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,10)..")",npcnamecolor), --burning steppes
                  [31850] = AddColor(GetAchievementCriteriaInfo(42,7),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,4)..")",npcnamecolor), --duskwood
                  [31913] = AddColor(GetAchievementCriteriaInfo(42,18),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,11)..")",npcnamecolor),--swamp of sorrows
                  [31693] = AddColor(GetAchievementCriteriaInfo(42,1),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,1)..")",npcnamecolor), --elwynn forest
                  [31912] = AddColor(GetAchievementCriteriaInfo(42,13),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,9)..")",npcnamecolor),--searing gorge
                  [31781] = AddColor(GetAchievementCriteriaInfo(42,10),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,3)..")",npcnamecolor),--redridge mountains
                  [31780] = AddColor(GetAchievementCriteriaInfo(42,20),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,2)..")",npcnamecolor), --westfall
                  [31852] = AddColor(GetAchievementCriteriaInfo(42,16),zonecolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,5)..")",npcnamecolor)} }--northern stranglethorn

-- check for active world events
local function AddWorldEventTamers()
 local i
 local _,_,today = CalendarGetDate()
 for i = 1,CalendarGetNumDayEvents(0,today) do
  local title = CalendarGetDayEvent(0, today, i)
  table.foreach(WEtable,function(k,v)
   if title == k then
    if not satchels_table[WEheader] then satchels_table[WEheader] = {} end
    satchels_table[WEheader][v.questID] = v.name
   end
  end)
 end
 --worldeventschecked = true
end

local function DrawTCheckTooltip(obj, tab)

 --if not worldeventschecked then
 AddWorldEventTamers()
 --end

 obj:ClearLines()
 obj:AddDoubleLine("Daily Tamer Check","|T"..dtcicon..":32|t")

  table.foreach(tab,function(k,v)
   obj:AddLine(" ")
   obj:AddLine(k)
   table.foreach(v,
    function(questID,questName)
    if IsQuestFlaggedCompleted(questID) then 
     obj:AddDoubleLine(AddColor(questName,GREY),AddColor(COMPLETE,LIGHT_GREEN))
    else
     obj:AddDoubleLine(AddColor(questName,GREY),AddColor(INCOMPLETE,LIGHT_RED))
    end
   end)
  end)
end

local function DrawTCheckFrame(obj, tab)
 local tmpleft  = ""
 local tmpright = ""
 obj.leftfont:SetText("a")
 local tmplen = obj.leftfont:GetStringWidth()

 local function adddoubleline(s1,s2,col1,col2)
  tmpleft  = tmpleft.."\n"..AddColor(s1,col1)
  tmpright = tmpright.."\n"..AddColor(s2,col2)
  
  s1 = string.gsub(s1,"|c........","")
  s1 = string.gsub(s1,"|r","")

  if ((tmplen * strlen(s1..""..s2)) > obj.maxwidth) then
   obj.maxwidth = tmplen * strlen(s1..""..s2)
  end

 end
 
  table.foreach(tab,function(k,v)
   adddoubleline("","",GREY,GREY)
   adddoubleline(k,"",GOLD,GREY)
   table.foreach(v,
    function(questID,questName)
    if IsQuestFlaggedCompleted(questID) then 
     adddoubleline(questName,COMPLETE,GREY,LIGHT_GREEN)
    else
     adddoubleline(questName,INCOMPLETE,GREY,LIGHT_RED)
    end
   end)
  end)

 obj.leftfont:SetText(tmpleft)
 obj.rightfont:SetText(tmpright)
end

local function CheckFramesAnimation(id)
 if (frame[id]) and (frame[id]:IsVisible()) and (frame[id].maxwidth ~= nil) and (frame[id].width ~= nil) and (frame[id].opening ~= nil) then
  if frame[id].opening then
   if frame[id].width < frame[id].maxwidth then
    frame[id].width = frame[id].width + opt_framespeed
    if id == ABOUT then
     frame[id]:SetHeight(frame[id].width)
    else
     frame[id]:SetWidth(frame[id].width)
    end
   elseif (not frame[id].leftfont:IsVisible()) then
    frame[id].leftfont:Show()
    frame[id].rightfont:Show()
   end
  else
   if frame[id].width > opt_framespeed then
    frame[id].width = frame[id].width - opt_framespeed
    if id == ABOUT then
     frame[id]:SetHeight(frame[id].width)
    else
     frame[id]:SetWidth(frame[id].width)
    end
    if (frame[id].leftfont:IsVisible()) then
     frame[id].leftfont:Hide()
     frame[id].rightfont:Hide()
    end
   else
    frame[id]:Hide()
   end
  end
 end
end

local function CreateNewFrameButton(id,tab,pos,tx)
  if not btn[id] then
   btn[id] = CreateFrame("FRAME", nil, mainframe)
  end
  if pos == "left" then
   btn[id]:SetPoint("BOTTOMLEFT", mainframe, "BOTTOMLEFT",10,10)
  elseif pos == "right" then
   btn[id]:SetPoint("BOTTOMRIGHT", mainframe, "BOTTOMRIGHT",-10,10)
  elseif pos == "bottom" then
   btn[id]:SetPoint("BOTTOMRIGHT", mainframe, "BOTTOMRIGHT",-45,10)
  end
  btn[id]:SetWidth(25)
  btn[id]:SetHeight(25)
  btn[id].texture = btn[id]:CreateTexture()
  btn[id].texture:SetAllPoints()
  btn[id].texture:SetTexture(tx)
  btn[id]:SetScript("OnEnter", function(self)
   if not frame[id] then
    frame[id] = CreateFrame("Frame")

    frame[id].texture = frame[id]:CreateTexture()
    frame[id].texture:SetAllPoints()
    frame[id].texture:SetTexture(0,0,0,0.7)
    
    frame[id].leftfont = frame[id]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
    frame[id].leftfont:SetParent(frame[id])
    frame[id].leftfont:SetPoint("TOPLEFT",10,-10)
    frame[id].leftfont:SetText("prova")

    frame[id].rightfont = frame[id]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
    frame[id].rightfont:SetParent(frame[id])
    frame[id].rightfont:SetPoint("TOPRIGHT",-10,-10)
    frame[id].rightfont:SetText("prova")
    
    frame[id].width = 1
    if id == ABOUT then
     frame[id].leftfont:SetText(AddColor(" Daily Tamer Check ",GOLD).."\n"..
                                         AddColor(" by\n",GREY)..
                                         AddColor(" Fluffies",LIGHT_BLUE)..
                                         AddColor(" EU-Well of Eternity",GREY))
     frame[id].rightfont:SetText("|T"..dtcicon..":24|t\n")
     frame[id].maxwidth = 60
    else
     frame[id].maxwidth = 200
    end
   end
   
   frame[id].leftfont:Hide()
   frame[id].rightfont:Hide()

   frame[id]:SetFrameStrata("DIALOG")
   frame[id]:SetToplevel(true)
   frame[id]:SetScale(0.9)
   frame[id]:SetClampedToScreen(true)
   frame[id]:ClearAllPoints()
   if pos == "left" then
    frame[id]:SetPoint("TOPRIGHT", mainframe, "TOPLEFT")
    frame[id]:SetPoint("BOTTOMRIGHT", mainframe, "BOTTOMLEFT")
   elseif pos == "right" then
    frame[id]:SetPoint("TOPLEFT", mainframe, "TOPRIGHT")
    frame[id]:SetPoint("BOTTOMLEFT", mainframe, "BOTTOMRIGHT")
   elseif pos == "bottom" then
    frame[id]:SetPoint("TOPLEFT", mainframe, "BOTTOMLEFT")
    frame[id]:SetPoint("TOPRIGHT", mainframe, "BOTTOMRIGHT")
   end
   frame[id].opening = true
   frame[id]:SetWidth(frame[id].width)
   if tab then
    DrawTCheckFrame(frame[id], tab)
   end
   
   frame[id]:Show()
  end)

  btn[id]:SetScript("OnLeave", function(self)
   if frame[id] then 
    frame[id].opening = false 
   end
  end)

  btn[id]:Show()
end --CreateNewFrameButton

local function tamerquestcheck()

 if not mainframe then
  mainframe = CreateFrame("GameTooltip", "dtcmainframe", nil, "GameTooltipTemplate")
 end
 mainframe:SetOwner(UIParent)
 mainframe:SetFrameStrata("HIGH")
 mainframe:EnableMouse(true)
 mainframe:SetToplevel(true)
 mainframe:SetMovable()
 mainframe:SetPadding(16)
 mainframe:SetScale(0.9)
 mainframe:RegisterForDrag("LeftButton")
 mainframe:SetScript("OnDragStart", function(self) 
		self:StartMoving( )
 end)
 mainframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing()
 end)
 -- frames closing animation
  mainframe:SetScript("OnUpdate", function(self)
   if frame[ONC] then
    CheckFramesAnimation(ONC)
   end
   if frame[EKK] then
    CheckFramesAnimation(EKK)
   end
   if frame[ABOUT] then
    CheckFramesAnimation(ABOUT)
   end
  end)
 DrawTCheckTooltip(mainframe,satchels_table)
 mainframe:AddLine(" ")
 mainframe:AddLine(" ")
 mainframe:AddLine(" ")
 
 if not btnclose then
  btnclose = CreateFrame("Button", "dtcclosebtn", mainframe, "UIPanelButtonTemplate")
 end
 btnclose:SetPoint("BOTTOM", mainframe, "BOTTOM",0,10)
 btnclose:SetWidth(150)
 btnclose:SetText("Close")
 btnclose:SetScript("OnClick", function(self)
  mainframe:Hide()
  if frame then
   table.foreach(frame,function(k,v) frame[k]:Hide() end)
  end
 end)

 btnclose:Show()
 
 CreateNewFrameButton(EKK,eastern_kalim_table,"left",tx_btnkalim)
 CreateNewFrameButton(ONC,out_north_cata_table,"right",tx_btnnorth)
 CreateNewFrameButton(ABOUT,nil,"bottom",tx_btnabout)

 mainframe:Show()
end

local DailyTamerCheck = ldb:NewDataObject("DailyTamerCheck", {
	type = "data source",
	icon = dtcicon,
	label = "Daily Tamer Check",
	OnClick = function(_,button)
         tamerquestcheck()
	end,
	OnTooltipShow = function(tooltip)
		 DrawTCheckTooltip(tooltip,satchels_table)
	end,
})

local eventframe = CreateFrame("FRAME","DTCEventFrame")
eventframe:RegisterEvent("PLAYER_ENTERING_WORLD");
local function eventhandler(self, event, ...)
 if event == "PLAYER_ENTERING_WORLD" then
  OpenCalendar()
  --eventframe:UnregisterEvent("PLAYER_ENTERING_WORLD")
  --eventframe = nil
 end
end
eventframe:SetScript("OnEvent", eventhandler);

-- slash command
SLASH_DAILYTAMERCHECK1 = "/dtcheck"
SLASH_DAILYTAMERCHECK2 = "/dtc"
SlashCmdList["DAILYTAMERCHECK"] = tamerquestcheck